<?php
/*
 /////////////////// DISCLAIMER ///////////////////////////
 THIS EXAMPLE CODE IS PROVIDED TO YOU ONLY ON AN "AS IS"
 BASIS WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
 MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 PAYPAL MAKES NO WARRANTY THAT THE SOFTWARE OR
 DOCUMENTATION WILL BE ERROR-FREE. IN NO EVENT SHALL THE
 COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ////////////////////////////////////////////////////////////
 */

//Get access token from PayPal
include 'create-token.php';

//Print all errors
error_reporting(E_ALL);
ini_set("display_errors", 1);


//Initiate CURL and set the url endpoint
$ch = curl_init();
$url = 'https://api.sandbox.paypal.com/v2/checkout/orders';
curl_setopt($ch, CURLOPT_URL, $url);

curl_setopt($ch, CURLOPT_SSLVERSION, CURL_SSLVERSION_TLSv1_2);

//Should to be set to true for security
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
//Should be set to 2 for security
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);

//Cert can be generated through mozilla firefox and is used when implementing security for VERIFYPEER and VERIFYHOST in the above
//curl_setopt($ch, CURLOPT_CAINFO, '/var/www/html/Example_REST_ECS/cert/cacert.pem');

//Set the required headers
$headers = array(
    //'Accept: application/json',
    'Content-Type: application/json',
    "Authorization: Bearer $accessToken"
);
curl_setopt($ch,CURLOPT_HTTPHEADER,$headers);

//Lets curl know we are using 'post' and not 'get' (false = 'get')
curl_setopt($ch, CURLOPT_POST, TRUE);

//Keep connection open until we get data back
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);

$vars =[];
//Specify we want to capture the payment, change this to 'AUTHORIZE' if you only want authorize the payment 
$vars['intent'] = 'CAPTURE';

//Define the shipping rules
//$applicationContext['shipping_preference'] = 'NO_SHIPPING';
$applicationContext['shipping_preference'] = 'GET_FROM_FILE';
$vars['application_context'] = $applicationContext;

//Specify currency and amount for transaction
$amount['currency_code'] = 'GBP';
$amount['value'] = '110.00';

$item_total['currency_code'] = "GBP";
$item_total['value'] = '90.00';

$shipping['currency_code'] = 'GBP';
$shipping['value'] = '20.00';

$tax['currency_code'] = 'GBP';
$tax['value'] = '0.00';


$breakdown['item_total'] = $item_total;
$breakdown['shipping'] = $shipping;
$breakdown['tax'] = $tax;

$amount['breakdown'] = $breakdown;

//Add the transaction values to the amount array
$purchase_units['amount'] = $amount;
$purchase_units['description'] = 'Transaction description';

$unitAmt['currency_code'] = 'GBP';
$unitAmt['value'] = '90.00';

$taxAmt['currency_code'] = 'GBP';
$taxAmt['value'] = '0.00';

$item1['name'] = 'Product 1';
$item1['description'] = 'Product 1 description';
$item1['unit_amount'] = $unitAmt;
$item1['currency_code'] = 'GBP"';
$item1['tax'] = $taxAmt;
$item1['quantity'] = '1';
$item1['category'] = 'PHYSICAL_GOODS';


//Add the transaction items to the item array
$purchase_units['items'] = array($item1);



//Add the purchase_units array to the main array
$vars['purchase_units'] = Array($purchase_units);

//Build and set the request
$json ='';
$json = json_encode($vars);
curl_setopt($ch, CURLOPT_POSTFIELDS, $json);

//echo $json;

//Get the response back
$response = curl_exec($ch);

//parse json into object
$outArray = json_decode($response, true);

//Set the order id in the session for later use
$_SESSION['orderId'] = $outArray['id'];

//print the response to be returned to the javascript the initially called it
echo $response;

//Close the connection
curl_close($ch);

