<!-- 
 /////////////////// DISCLAIMER ///////////////////////////
 THIS EXAMPLE CODE IS PROVIDED TO YOU ONLY ON AN "AS IS"
 BASIS WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
 MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 PAYPAL MAKES NO WARRANTY THAT THE SOFTWARE OR
 DOCUMENTATION WILL BE ERROR-FREE. IN NO EVENT SHALL THE
 COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ////////////////////////////////////////////////////////////
 */
  -->
<!DOCTYPE html>

<head>
    <!-- Add meta tags for mobile and IE -->
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
</head>

<body>
    <!-- Set up a container element for the button -->
    <div id="paypal-button-container"></div>

    <!-- Include the PayPal JavaScript SDK -->
    <!-- Add 'intent=authorize' if you only want to authorize the payment -->
    <!-- https://developer.paypal.com/docs/checkout/reference/customize-sdk/#disable-funding -->
    <script src="https://www.paypal.com/sdk/js?client-id=AcNEYyp4KIYuTLS9KOsZr9Ua0Gi2c4p5dOSfSnoYTL9ZgdpNyNEvTE6LaF60Xy89BkMGFFMw4HxSb5Tf&currency=GBP&disable-funding=card"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>

    <script>
        // Render the PayPal button into #paypal-button-container
        paypal.Buttons({


            // Set up the transaction
            createOrder: function(data, actions) {
                //Setup path to create order file
                return fetch('http://localhost/Sample_REST_Payments_V2(Captures)/createOrder.php', {
                    method: 'post'
                }).then(function(res) {
                    return res.json();
                }).then(function(data) {
                    console.log(data);
                    return data.id;
                });
            },

            //If shipping costs change depending on the delivery address this is where you can add more vaule to the shipping costs
            //https://developer.paypal.com/docs/checkout/integration-features/shipping-callback/
         onShippingChange: function(data, actions){

             console.log(data);

					//sGet the shipping address that they have chosen on PayPal login			
             let shipping_address = data.shipping_address;
             console.log(shipping_address);

					//Call the file in which you will calculate the new shipping costs and send the new shipping data
            return fetch("http://localhost/Sample_REST_Payments_V2(Captures)/calculate_shipping.php", {
              
             	method: "post",
             	body: JSON.stringify({"shipping": shipping_address})
             }).then(function(res){
            	 
             	return res.json();
             	
             }).then(function(data){
            	 
             	console.log(data);
             	
             	
             
					  //Define the new shipping amount and add this to the total and patch the new amount to the transaction data
               let shippingAmount = parseFloat(data.new_shipping_costs);
               let baseOrderAmount = 90.00;
               
               	//If needed you can restrict the countries that you wish to ship to and reject the transaction if it is within the restricted country
               if(shipping_address.country_code === "ES"){
                 return  actions.reject();
               }

               console.log("data: " + (baseOrderAmount).toFixed(2));

               	//patch the new costs onto the transaction data   ***Hard coding values for now****
               return actions.order.patch([
                   {
                       op: 'replace',
                       path: "/purchase_units/@reference_id=='default'/amount",
                       value: {
                           currency_code: 'GBP',
                           value: (baseOrderAmount + shippingAmount).toFixed(2),
                           breakdown: {
                               item_total: {
                                   currency_code: 'GBP',
                                   value: baseOrderAmount
                               },
                               shipping: {
                                   currency_code: 'GBP',
                                   value: shippingAmount
                               }
                           }
                       }
                   }
               ]);

             }); 
           
           },

            // Finalize the transaction
            onApprove: function(data, actions) {
                return fetch('http://localhost/Sample_REST_Payments_V2(Captures)/capturePaymentForOrder.php', {
                    method: 'post'
                }).then(function(res) {
                    return res.json();
                }).then(function(details) {
                    // Show a success message to the buyer
                    alert('Transaction completed by ' + details.payer.name.given_name + '!');
                    //Can get all user details from this object
                    console.log(details);
                    //Once payment is complete show the order details
                    //window.location.replace("http://localhost/Sample_REST_Payments_V2(Captures)/showOrderDetails.php");
                });
            },

            // onClick is called when the button is clicked
//             onClick: function() {
            	
//               }


        }).render('#paypal-button-container');
    </script>
</body>