<?php
/*
 /////////////////// DISCLAIMER ///////////////////////////
 THIS EXAMPLE CODE IS PROVIDED TO YOU ONLY ON AN "AS IS"
 BASIS WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
 MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 PAYPAL MAKES NO WARRANTY THAT THE SOFTWARE OR
 DOCUMENTATION WILL BE ERROR-FREE. IN NO EVENT SHALL THE
 COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ////////////////////////////////////////////////////////////
 */

//Print all errors
error_reporting(E_ALL);
ini_set("display_errors", 1);

//Start the PHP session
session_start();

//Get teh access token from the session
$accessToken = $_SESSION['accessToken'];

//Get the capture id from the session
$captureId = $_SESSION['captureId'];

//Initiate CURL and set the url endpoint including the capture id for the payment to be refunded
$ch = curl_init();
$url = "https://api.sandbox.paypal.com/v2/payments/captures/$captureId/refund";
curl_setopt($ch, CURLOPT_URL, $url);

curl_setopt($ch, CURLOPT_SSLVERSION, CURL_SSLVERSION_TLSv1_2);

//Should to be set to true for security
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
//Should be set to 2 for security
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);

//Cert can be generated through mozilla firefox and is used when implementing security for VERIFYPEER and VERIFYHOST in the above
//curl_setopt($ch, CURLOPT_CAINFO, '/var/www/html/Example_REST_ECS/cert/cacert.pem');

//Set the required headers
$headers = array(
    'Accept: application/json',
    'Content-Type: application/json',
    "Authorization: Bearer $accessToken"
);
curl_setopt($ch,CURLOPT_HTTPHEADER,$headers);

//Lets curl know we are using 'post' and not 'get' (false = 'get')
curl_setopt($ch, CURLOPT_POST, TRUE);

//Keep connection open until we get data back
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);


//Optionally specify currency and refund amount for transaction

// $amount['currency_code'] = 'GBP';
// $amount['value'] = '100.00';

//Add the transaction values to the amount array
//$vars['amount'] = $amount;
//$vars['note_to_payer'] = "Defective product";

//Build and set the request
// $json = json_encode($vars);
// curl_setopt($ch, CURLOPT_POSTFIELDS, $json);


//Get the response back
$response = curl_exec($ch);

//parse json into a php array
$outArray = json_decode($response, true);

//Set the refund id in the session for later use
$_SESSION['refundId'] = $outArray['id'];

//Print the response
echo "<pre>";
print_r($outArray);
echo "</pre></br>";

//Close the connection
curl_close($ch);

?>

<!DOCTYPE html>

<head>
<!-- Add meta tags for mobile and IE -->
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta http-equiv="X-UA-Compatible" content="IE=edge" />

<style type="text/css">
a.button {
    -webkit-appearance: button;
    -moz-appearance: button;
    appearance: button;
    
    text-decoration: none;
    color: initial;
    width:33.3%;
}

.bar{
    margin-left: 10%;
}
​
</style>
</head>

<body>

<div class="bar">
<a href="http://localhost/Sample_REST_Payments_V2(Captures)/showRefundDetails.php" class="button">Show Refund Details</a>


</div>

</body>




